% function to calculate the disorientation angle
% from the misorientation Q given as quaternion
% taking into account crystalline symmetry
% here only simplified version for cubic symmetry
% based on maps of quaternions 
function dQ = disorientation(Qa,Qb,Qc,Qd);

Q(1,:,:) = Qa;
Q(2,:,:) = Qb;
Q(3,:,:) = Qc;
Q(4,:,:) = Qd;

Q = sort(abs(Q),1);

% Q(5,:,:) = Q(3,:,:) + Q(4,:,:);
% Q(6,:,:) = Q(1,:,:) + Q(2,:,:) + Q(5,:,:);
% Q(5,:,:) = Q(5,:,:)/sqrt(2);
% Q(6,:,:) = Q(6,:,:)/2;
% Q = sort(Q,1);
% dQ(:,:) = Q(6,:,:);

QQ(1,:,:) = Q(4,:,:);
QQ(2,:,:) = Q(3,:,:) + Q(4,:,:);
QQ(3,:,:) = Q(1,:,:) + Q(2,:,:) + QQ(2,:,:);
QQ(2,:,:) = QQ(2,:,:)/sqrt(2);
QQ(3,:,:) = Q(3,:,:)/2;
QQ = sort(QQ,1);
dQ(:,:) = QQ(3,:,:);


